package cn.estsh.i3plus.pojo.base.enumutil;

import java.math.BigDecimal;
import java.net.URL;
import java.sql.*;

/**
 * @author Wynne.Lu
 * @date 2021/3/22 下午5:16
 * @desc
 */
public class ScreenEnumUtil {

    public enum DATA_OBJECT_SOURCE {
        TABLE(1, "TABLE", "数据库表"),
        VIEW(2, "VIEW", "数据库视图");

        private Integer value;
        private String code;
        private String description;

        DATA_OBJECT_SOURCE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static Integer codeOfValue(String code) {
            Integer tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static DATA_OBJECT_SOURCE valueOfEnum(Integer value) {
            DATA_OBJECT_SOURCE tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value.equals(value)) {
                    tmp = values()[i];
                }
            }
            return tmp;
        }
    }

    public enum SCREEN_TYPE {
        PC(10, "PC", "PC端"),
        PDA(20, "PDA", "PDA手持端");

        private Integer value;
        private String code;
        private String description;

        SCREEN_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum ACTION_TYPE {
        FRONT(10, "FRONT", "前端"),
        BACKEND(20, "BACKEND", "后端");

        private Integer value;
        private String code;
        private String description;

        ACTION_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum NULLABLE {
        YES(10, "YES", "允许为空"),
        NO(20, "NO", "不允许为空");

        private Integer value;
        private String code;
        private String description;

        NULLABLE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static NULLABLE valueOfEnum(Integer value) {
            NULLABLE tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value.equals(value)) {
                    tmp = values()[i];
                }
            }
            return tmp;
        }
    }

    public enum INDEX_TYPE {
        PRIMARY(10, "PRIMARY", "主键"),
        NORMAL(20, "NORMAL", "普通索引"),
        UNIQUE(30, "UNIQUE", "唯一键");

        private Integer value;
        private String code;
        private String description;

        INDEX_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum DEFAULT_FIELD_IN_DB {
        CREATE_DATE_TIME("createDatetime", "create_date_time", "创建时间"),
        MODIFY_DATE_TIME("modifyDatetime", "modify_date_time", "修改时间"),
        IS_VALID("isValid", "is_valid", "是否有效"),
        IS_DELETED("isDeleted", "is_deleted", "是否弱删");

        private String code;
        private String codeDb;
        private String description;

        DEFAULT_FIELD_IN_DB(String code, String codeDb, String description) {
            this.code = code;
            this.codeDb = codeDb;
            this.description = description;
        }

        public String getCode() {
            return code;
        }

        public String getCodeDb() {
            return codeDb;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum LAYOUT_TYPE {
        SCREEN(10, "SCREEN", "Screen布局"),
        PANEL(20, "PANEL", "Panel布局");

        private Integer value;
        private String code;
        private String description;

        LAYOUT_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum DATASOURCE_CONNECTION_STATUS {
        SUCCESS(10, "success", "连接成功"),
        FAILED(20, "failed", "连接失败");

        private Integer value;
        private String code;
        private String description;

        DATASOURCE_CONNECTION_STATUS(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum ACTION {
        SEARCH(10, "search", "查询", "scrSearchActionStrategy"),
        CREATE(20, "create", "保存", "scrCreateActionStrategy"),
        UPDATE(30, "update", "更新", "scrUpdateActionStrategy"),
        DELETE(40, "delete", "删除", "scrDeleteActionStrategy"),
        VALID(50, "valid", "启用", "scrValidActionStrategy"),
        INVALID(60, "invalid", "禁用", "scrInvalidActionStrategy"),
        SEARCH_PAGER(70, "searchPager", "分页查询", "scrSearchPagerActionStrategy"),
        ENUM(80, "enum", "枚举查询", "scrEnumActionStrategy"),
        DIRECT(90, "direct", "跳转", "scrDirectActionStrategy"),
        DOWNLOAD(100, "download", "下载", "scrDownloadActionStrategy"),
        UPLOAD(110, "upload", "上传", "scrUploadActionStrategy"),
        INVOKE(120, "invoke", "调用", "scrInvokeActionStrategy");

        private Integer value;
        private String code;
        private String description;
        private String beanName;

        ACTION(Integer value, String code, String description, String beanName) {
            this.value = value;
            this.code = code;
            this.description = description;
            this.beanName = beanName;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String beanOfCode(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equalsIgnoreCase(code)) {
                    tmp = values()[i].beanName;
                }
            }
            return tmp;
        }

        public static ACTION codeOfEnum(String code) {
            ACTION tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equalsIgnoreCase(code)) {
                    tmp = values()[i];
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }


    public enum COMMUNICATION_TYPE {
        HTTP(10, "HTTP", "Http"),
        WEBSOCKET(20, "WEBSOCKET", "WebSocket");

        private Integer value;
        private String code;
        private String description;

        COMMUNICATION_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum DATA_RESOURCE_TYPE {
        ENUM(10, "enum", "枚举"),
        WEBSOCKET(20, "WEBSOCKET", "WebSocket");

        private Integer value;
        private String code;
        private String description;

        DATA_RESOURCE_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum MODEL_TYPE {
        DATA_OBJECT(10, "DATA_OBJECT", "数据库对应类型"),
        INNER_MODEL(20, "INNER_MODEL", "程序内部对应类型");

        private Integer value;
        private String code;
        private String description;

        MODEL_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum DATETIME_FORMAT {
        DATETIME(10, "yyyy-MM-dd HH:mm:ss", "日期"),
        DATE(20, "yyyy-MM-dd", "日期"),
        TIME(30, "HH:mm:ss", "时间"),
        TIME_NO_SECOND(40, "HH:mm", "时间（无秒）");


        private Integer value;
        private String code;
        private String description;

        DATETIME_FORMAT(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum MODEL_FIELD_DATASOURCE {
        FROM_TEXT(10, "TEXT", "文本"),
        FROM_NUMBER(20, "NUMBER", "数字"),
        FROM_PASSWORD(30, "PASSWORD", "密码"),
        FROM_DATETIME(40, "DATETIME", "时间"),
        FROM_PICK_UP(50, "PICK_UP", "拾取"),
        FROM_ENUM(60, "ENUM", "枚举"),
        FROM_DICTIONARY(70, "DICTIONARY", "字典"),
        FROM_API(80, "API", "API调用");

        private Integer value;
        private String code;
        private String description;

        MODEL_FIELD_DATASOURCE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum AUTH_TYPE {
        ROW(10, "ROW", "行"),
        COLUMN(20, "COLUMN", "列");

        private Integer value;
        private String code;
        private String description;

        AUTH_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum JDBC_TYPES {
        BIT(Types.BIT, "BIT", Boolean.class),
        TINYINT(Types.TINYINT, "TINYINT", Byte.class),
        SMALLINT(Types.SMALLINT, "SMALLINT", Short.class),
        INTEGER(Types.INTEGER, "INTEGER", Integer.class),
        BIGINT(Types.BIGINT, "BIGINT", Long.class),
        FLOAT(Types.FLOAT, "FLOAT", Double.class),
        REAL(Types.REAL, "REAL", Float.class),
        DOUBLE(Types.DOUBLE, "DOUBLE", Double.class),
        NUMERIC(Types.NUMERIC, "NUMERIC", BigDecimal.class),
        DECIMAL(Types.DECIMAL, "DECIMAL", BigDecimal.class),
        CHAR(Types.CHAR, "CHAR", String.class),
        VARCHAR(Types.VARCHAR, "VARCHAR", String.class),
        LONGNVARCHAR(Types.LONGNVARCHAR, "LONGNVARCHAR", String.class),
        DATE(Types.DATE, "DATE", Date.class),
        TIME(Types.TIME, "TIME", Time.class),
        TIMESTAMP(Types.TIMESTAMP, "TIMESTAMP", Timestamp.class),
        BINARY(Types.BINARY, "BINARY", Byte[].class),
        VARBINARY(Types.VARBINARY, "VARBINARY", Byte[].class),
        LONGVARBINARY(Types.LONGVARBINARY, "LONGVARBINARY", Byte[].class),
        STRUCT(Types.STRUCT, "STRUCT", Struct.class),
        ARRAY(Types.ARRAY, "ARRAY", Array.class),
        BLOB(Types.BLOB, "BLOB", Blob.class),
        CLOB(Types.CLOB, "CLOB", Clob.class),
        REF(Types.REF, "REF", Ref.class),
        DATALINK(Types.DATALINK, "DATALINK", URL.class),
        BOOLEAN(Types.BOOLEAN, "BOOLEAN", Boolean.class),
        NCHAR(Types.NCHAR, "NCHAR", String.class),
        NVARCHAR(Types.NVARCHAR, "NVARCHAR", String.class),
        LONGVARCHAR(Types.LONGVARCHAR, "LONGVARCHAR", String.class),
        NCLOB(Types.NCLOB, "NCLOB", NClob.class),
        SQLXML(Types.SQLXML, "SQLXML", String.class);

        private Integer value;
        private String code;
        private Class clazz;

        JDBC_TYPES(Integer value, String code, Class clazz) {
            this.value = value;
            this.code = code;
            this.clazz = clazz;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public Class getClazz() {
            return clazz;
        }

        public static Integer valueOfCode(String code) {
            Integer tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static JDBC_TYPES valueOfEnum(Integer value) {
            JDBC_TYPES tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value.equals(value)) {
                    tmp = values()[i];
                }
            }
            return tmp;
        }
    }


}
