package cn.estsh.i3plus.pojo.mes.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Description: 特殊物料
 * @Author: jokelin
 * @Date: 2021/3/24 3:10 PM
 * @Modify:
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "MES_PART_CAR_MODEL")
@Api("车型零件关系表")
public class MesPartCarModel extends BaseBean implements Serializable {

    private static final long serialVersionUID = -4039513102671811231L;

    @Column(name = "PART_NO")
    @ApiParam("零件号")
    private String partNo;

    @Column(name = "PART_NAME")
    @ApiParam("零件名称")
    private String partNameRdd;

    @Column(name = "VEHICLE_CODE")
    @ApiParam("车型代码")
    private String vehicleCode;

    @Column(name = "VEHICLE_NAME")
    @ApiParam("车型名称")
    private String vehicleName;

    @Column(name = "SERIAL_NO")
    @ApiParam("车型流水号")
    private String serialNo;

}
