package cn.estsh.i3plus.pojo.mes.model.report;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * 产品履历报表-产品信息
 * @author yumingxing
 * @version 1.0
 * @date 2020/12/18 15:16
 **/
@Data
@ApiModel("产品履历报表-产品信息")
public class ProductSnModel implements Serializable {

    private static final long serialVersionUID = 7137684552464509466L;

    @ApiParam("包装条码")
    private String packageNo;

    @ApiParam("客户零件号")
    private String customerPartNo;

    @ApiParam("零件二维码")
    private String serialNumber;

    @ApiParam("CMS零件号")
    private String partNo;

    @ApiParam("CMS标签号")
    private String qrCode;

    @ApiParam("产线")
    private String workCenterName;

    @ApiParam("工序名称")
    private String processName;

    @ApiParam("工位名称")
    private String workCellName;

    @ApiParam(value = "扫码时间")
    public String createDatetime;

    @ApiParam(value = "执行人")
    public String createUser;

    @ApiParam("质量代码")
    private Integer qcStatus;

    @ApiParam("质量状态")
    private String qcStatusName;




    public ProductSnModel(String packageNo,String customerPartNo, String serialNumber, String partNo,
                          String qrCode, String workCenterName, String processName,
                          String workCellName, String createDatetime,
                          String createUser, Integer qcStatus) {
        this.packageNo = packageNo;
        this.customerPartNo = customerPartNo;
        this.serialNumber = serialNumber;
        this.partNo = partNo;
        this.qrCode = qrCode;
        this.workCenterName = workCenterName;
        this.processName = processName;
        this.workCellName = workCellName;
        this.createDatetime = createDatetime;
        this.createUser = createUser;
        this.qcStatus = qcStatus;
    }
}
