package cn.estsh.i3plus.pojo.screen.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.ScreenEnumUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2021/3/11 下午12:29
 * @desc
 */
@Entity
@Table(name = "SCR_DATA_AUTH")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ApiModel("数据权限")
public class ScrDataAuth extends BaseBean implements Serializable {
    private static final long serialVersionUID = 8099384243374450186L;

    @Column(name = "MODEL_CODE")
    @ApiModelProperty("model代码")
    private String modelCode;

    @Column(name = "MODEL_FIELD_CODE")
    @ApiModelProperty("model字段代码")
    private String modelFieldCode;

    @Column(name = "MODEL_FIELD_CONDITION")
    @ApiModelProperty("model字段条件")
    private String modelFieldCondition;

    @Column(name = "ACCESS_ROLES")
    @ApiModelProperty("可以访问的角色")
    private String accessRoles;

    @Column(name = "DENIED_ROLES")
    @ApiModelProperty("拒绝访问的角色")
    private String deniedRoles;

    @Column(name = "ACCESS_USERS")
    @ApiModelProperty("可以访问的用户")
    private String accessUsers;

    @Column(name = "DENIED_USERS")
    @ApiModelProperty("拒绝访问的用户")
    private String deniedUsers;

    @Column(name = "AUTH_TYPE")
    @ApiModelProperty("权限类型 （行，列）")
    @Enumerated(EnumType.STRING)
    private ScreenEnumUtil.AUTH_TYPE authType;


}
