package cn.estsh.i3plus.pojo.screen.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.ScreenEnumUtil;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2021/3/22 下午1:27
 * @desc 数据对象管理
 */
@Entity
@Table(name = "SCR_DATA_OBJECT")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ApiModel("数据对象管理")
public class ScrDataObject extends BaseBean implements Serializable {
    private static final long serialVersionUID = -270662014158685376L;

    @Column(name = "DATA_SOURCE_ID")
    @ApiModelProperty(value = "数据源ID", example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long dataSourceId;

    @Column(name = "DATA_OBJECT_CODE")
    @ApiModelProperty(value = "数据对象代码")
    private String dataObjectCode;

    @Column(name = "TABLE_NAME")
    @ApiModelProperty(value = "表或视图名称")
    private String tableName;

    @Column(name = "DATA_TYPE")
    @ApiModelProperty(value = "数据类型")
    @Enumerated(EnumType.STRING)
    private ScreenEnumUtil.DATA_OBJECT_SOURCE dataType;

    @Column(name = "FIELD_CODE")
    @ApiModelProperty(value = "字段代码")
    private String fieldCode;

    @Column(name = "FIELD_TYPE")
    @ApiModelProperty(value = "字段类型")
    @Enumerated(EnumType.STRING)
    private ScreenEnumUtil.JDBC_TYPES fieldType;

    @Column(name = "FIELD_SIZE")
    @ApiModelProperty(value = "字段长度")
    private Integer fieldSize;

    @Column(name = "DISPLAY_NAME")
    @ApiModelProperty(value = "字段名称")
    private String displayName;

    @Column(name = "DESCRIPTION")
    @ApiModelProperty(value = "描述")
    private String description;

    @Column(name = "NULLABLE")
    @ApiModelProperty("是否能为空")
    @Enumerated(EnumType.STRING)
    private ScreenEnumUtil.NULLABLE nullable;

}
