package cn.estsh.i3plus.pojo.screen.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.ScreenEnumUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2021/3/22 下午1:27
 * @desc
 */
@Entity
@Table(name = "SCR_DATA_OBJECT_INDEX")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ApiModel("数据对象约束管理")
public class ScrDataObjectIndex extends BaseBean implements Serializable {
    private static final long serialVersionUID = 8995523223574903326L;

    @Column(name = "DATA_OBJECT_CODE")
    @ApiModelProperty("数据对象代码")
    private String dataObjectCode;

    @Column(name = "INDEX_TYPE")
    @ApiModelProperty("约束类型")
    @Enumerated(EnumType.STRING)
    private ScreenEnumUtil.INDEX_TYPE indexType;

    @Column(name = "GROUP_NO")
    @ApiModelProperty("组号")
    private Integer groupNo;

    @Column(name = "FIELD_CODE")
    @ApiModelProperty("字段代码")
    private String fieldCode;

}
