package cn.estsh.i3plus.pojo.screen.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2021/3/19 下午5:06
 * @desc
 */
@Entity
@Table(name = "SCR_EVENT_ACTION")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ApiModel("事件动作")
public class ScrEventAction extends BaseBean implements Serializable {
    private static final long serialVersionUID = -6217007706865821613L;

    @Column(name = "EVENT_ACTION_CODE")
    @ApiModelProperty("事件动作CODE")
    private String eventActionCode;

    @Column(name = "EVENT_ACTION_NAME")
    @ApiModelProperty("事件动作名称")
    private String eventActionName;

    @Column(name = "EVENT_CODE")
    @ApiModelProperty("事件代码")
    private String eventCode;

    @Column(name = "PRE_ACTION_CODE")
    @ApiModelProperty("执行前动作代码")
    private String preActionCode;

    @Column(name = "EXECUTE_ACTION_CODE")
    @ApiModelProperty("执行的动作代码")
    private String executeActionCode;

    @Column(name = "POST_ACTION_CODE")
    @ApiModelProperty("执行前动作代码")
    private String postActionCode;
}
