package cn.estsh.i3plus.pojo.screen.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.ScreenEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2021/3/11 下午12:30
 * @desc
 */
@Entity
@Table(name = "SCR_LAYOUT")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ApiModel("布局")
public class ScrLayout extends BaseBean implements Serializable {
    private static final long serialVersionUID = 3390463604300159807L;

    @Column(name = "LAYOUT_CODE")
    @ApiModelProperty("布局代码")
    private String layoutCode;

    @Column(name = "LAYOUT_NAME")
    @ApiModelProperty("布局名称")
    private String layoutName;

    @Column(name = "LAYOUT_TYPE")
    @ApiModelProperty("布局类型")
    @Enumerated(EnumType.STRING)
    private ScreenEnumUtil.LAYOUT_TYPE layoutType;

}
