package cn.estsh.i3plus.pojo.screen.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.ScreenEnumUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2021/3/11 下午12:29
 * @desc
 */
@Entity
@Table(name = "SCR_MODEL")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ApiModel("model")
public class ScrModel extends BaseBean implements Serializable {
    private static final long serialVersionUID = -4609944173378718944L;

    @Column(name = "MODEL_CODE")
    @ApiModelProperty("model代码")
    private String modelCode;

    @Column(name = "MODEL_TYPE")
    @ApiModelProperty("model的类型")
    @Enumerated(EnumType.STRING)
    private ScreenEnumUtil.MODEL_TYPE modelType;

    @Column(name = "DATA_OBJECT_CODE")
    @ApiModelProperty("数据对象代码")
    private String dataObjectCode;

    @Column(name = "DATA_COlUMN_AUTH")
    @ApiModelProperty("数据列权限")
    private String dataColumnAuth;
}
