package cn.estsh.i3plus.pojo.screen.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.enumutil.ScreenEnumUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.io.Serializable;

/**
 * @author Wynne.Lu
 * @date 2021/3/11 下午12:29
 * @desc
 */
@Entity
@Table(name = "SCR_MODEL_FIELD")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ApiModel("model字段")
public class ScrModelField extends BaseBean implements Serializable {
    private static final long serialVersionUID = 3893137576091823152L;

    @Column(name = "MODEL_CODE")
    @ApiModelProperty("model代码")
    private String modelCode;

    @Column(name = "FIELD_CODE")
    @ApiModelProperty("字段代码")
    private String fieldCode;

    @Column(name = "DISPLAY_NAME")
    @ApiModelProperty("字段名称")
    private String displayName;

    @Column(name = "FIELD_NAME")
    @ApiModelProperty("字段名称")
    private String fieldName;

    @Column(name = "IS_FUZZY_SEARCH")
    @ApiModelProperty("是否支持模糊查询")
    private Boolean isFuzzySearch;

    @Column(name = "IS_SHOW_IN_NEW")
    @ApiModelProperty("是否在新增时展示")
    private Boolean isShowInNew;

    @Column(name = "IS_SHOW_IN_EDIT")
    @ApiModelProperty("是否在编辑时展示")
    private Boolean isShowInEdit;

    @Column(name = "IS_ALLOW_SORT")
    @ApiModelProperty("是否支持排序")
    private Boolean isAllowSort;

    @Column(name = "IS_REQUIRED")
    @ApiModelProperty("是否必填")
    private Boolean isRequired;

    @Column(name = "FORM_SEQ")
    @ApiModelProperty("表单顺序")
    private Integer formSeq;

    @Column(name = "TABLE_SEQ")
    @ApiModelProperty("表格顺序")
    private Integer tableSeq;

    @Column(name = "EXPORT_SEQ")
    @ApiModelProperty("导出顺序")
    private Integer exportSeq;

    @Column(name = "VALIDATION")
    @ApiModelProperty("校验")
    private String regexValidation;

    @Column(name = "IS_VIRTUAL")
    @ApiModelProperty("是否是虚拟的")
    private Boolean isVirtual;

    @Column(name = "MODEL_FIELD_DATASOURCE")
    @ApiModelProperty("字段数据来源")
    @Enumerated(EnumType.STRING)
    private ScreenEnumUtil.MODEL_FIELD_DATASOURCE modelFieldDatasource;

    @Column(name = "MODEL_FIELD_DATASOURCE_PROPS")
    @ApiModelProperty("model字段来源属性")
    private String modelFieldDatasourceProps;

    @Column(name = "DATA_ROW_AUTH")
    @ApiModelProperty("数据列权限")
    private String dataRowAuth;

    @Transient
    private Object fieldValue;


}
